org.apache.lucene.search

## Class BoostingQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.BoostingQuery

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class BoostingQuery
      extends Query

  The BoostingQuery class can be used to effectively demote results that match a given query. Unlike the "NOT" clause, this still selects documents that contain undesirable terms, but reduces their overall score: Query balancedQuery = new BoostingQuery(positiveQuery, negativeQuery, 0.01f); In this scenario the positiveQuery contains the mandatory, desirable criteria which is used to select all matching documents, and the negativeQuery contains the undesirable elements which are simply used to lessen the scores. Documents that match the negativeQuery have their score multiplied by the supplied "boost" parameter, so this should be less than 1 to achieve a demoting effect This code was originally made available here: [WWW] http://marc.theaimsgroup.com/?l=lucene-user&m=108058407130459&w=2 and is documented here: http://wiki.apache.org/lucene-java/CommunityContributions
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BoostingQuery(Query match, Query context, float boost)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`
    `Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
    `java.lang.String` | `toString(java.lang.String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

    - ### Methods inherited from class org.apache.lucene.search.Query

      `clone, combine, createWeight, extractTerms, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### BoostingQuery

          public BoostingQuery(Query match,
                               Query context,
                               float boost)

  - ### Method Detail

    - #### rewrite

          public Query rewrite(IndexReader reader)
                        throws java.io.IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.
      Overrides:
        `rewrite` in class `Query`
      Throws:
        `java.io.IOException`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Query`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `Query`

    - #### toString

          public java.lang.String toString(java.lang.String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.

      The representation used is one that is supposed to be readable by `QueryParser`. However, there are the following limitations:

      - If the query was created by the parser, the printed representation may not be exactly what was parsed. For example, characters that need to be escaped will be represented without the required backslash.
      - Some of the more complicated queries (e.g. span queries) don't have a representation that can be parsed by QueryParser.
      Specified by:
        `toString` in class `Query`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.